; OPT_Res	0	   ; RichMasm assumes this code needs no resources - delete if rsrc.rc is needed
include \masm32\include\masm32rt.inc
.586											; required for ptimers	
include ptimers.inc								; Petroizki's code timers

.data
	buffer					db	64 dup(0)
	max						dd	10101010101010101010101010101010y
	hProcess				dd	0
	mcx						dd	01010101010101010101010101010101y
	processAffinityMask		dd	0
	mdx						dd	00100100100100100100100100100100y
	systemAffinityMask		dd	0
	msi						dd	01001001001001001001001001001001y
	na						dd	0
	mdi						dd	10010010010010010010010010010010y
	nb						dd	0

.code
start:
	invoke GetCurrentProcess
	mov [hProcess],eax
; get the system and process affinity masks
	invoke GetProcessAffinityMask,[hProcess],addr processAffinityMask,
			addr systemAffinityMask
; set this processes priority to high
	invoke SetPriorityClass,[hProcess],HIGH_PRIORITY_CLASS
; and force it to only use one processor "core"
	invoke SetProcessAffinityMask,hProcess,1

	mov eax,[max]								; use ordered bit values
	mov ecx,[mcx]
	mov edx,[mdx]
	mov esi,[msi]
	mov edi,[mdi]



; ----------------------------------------------------------------------------
	print chr$(13,10,"Reference null tests:",13,10)
	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
; nothing in here...
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("Null:               %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x NOP:            %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer



; ----------------------------------------------------------------------------
	print chr$(13,10,"Failure-mode CMP tests:",13,10)	; testing CMP failures
	invoke Sleep,1000							; to let system state settle
PTIMER_START_LOOP_COUNT							; begin code timing loop here
	REPEAT 100
	cmp eax,ecx									; ordered to reduce stalls
	cmp edx,esi
	cmp edi,eax
	cmp ecx,edx
	cmp esi,edi
	cmp ecx,eax									; reversed sequence
	cmp esi,edx
	cmp eax,edi
	cmp edx,ecx
	cmp edi,esi
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x CMP REG,REG:    %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	cmp eax,01010101010101010101010101010101y
	cmp ecx,10101010101010101010101010101010y
	cmp edx,01001001001001001001001001001001y
	cmp esi,10010010010010010010010010010010y
	cmp edi,00100100100100100100100100100100y
	cmp eax,01010101010101010101010101010101y
	cmp ecx,10101010101010101010101010101010y
	cmp edx,01001001001001001001001001001001y
	cmp esi,10010010010010010010010010010010y
	cmp edi,00100100100100100100100100100100y
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x CMP REG,IMMED:  %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	cmp [max],ecx
	cmp [mdx],esi
	cmp [mdi],eax
	cmp [mcx],edx
	cmp [msi],edi
	cmp [mcx],eax
	cmp [msi],edx
	cmp [max],edi
	cmp [mdx],ecx
	cmp [mdi],esi
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x CMP MEM,REG:    %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	cmp [max],01010101010101010101010101010101y
	cmp [mcx],10101010101010101010101010101010y
	cmp [mdx],01001001001001001001001001001001y
	cmp [msi],10010010010010010010010010010010y
	cmp [mdi],00100100100100100100100100100100y
	cmp [max],01010101010101010101010101010101y
	cmp [mcx],10101010101010101010101010101010y
	cmp [mdx],01001001001001001001001001001001y
	cmp [msi],10010010010010010010010010010010y
	cmp [mdi],00100100100100100100100100100100y
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x CMP MEM,IMMED:  %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer


; ----------------------------------------------------------------------------
	print chr$(13,10,"Success-mode CMP tests:",13,10)
	rol ecx,1									; "fix" reg values
	ror esi,1									; eax == ecx
	rol edi,1									; edx == esi == edi
	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	cmp eax,ecx
	cmp edx,esi
	cmp ecx,eax
	cmp edi,edx
	cmp eax,ecx
	cmp edi,edx
	cmp ecx,eax
	cmp esi,edi
	cmp eax,ecx
	cmp esi,edx
	ENDM
PTIMER_END_LOOP_COUNT
	rol ecx,1									; restore
	ror esi,1
	rol edi,1
	invoke wsprintf,addr buffer,chr$("1000x CMP REG,REG:    %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	cmp eax,10101010101010101010101010101010y
	cmp ecx,01010101010101010101010101010101y
	cmp eax,10101010101010101010101010101010y
	cmp ecx,01010101010101010101010101010101y
	cmp edx,00100100100100100100100100100100y
	cmp esi,01001001001001001001001001001001y
	cmp edx,00100100100100100100100100100100y
	cmp esi,01001001001001001001001001001001y
	cmp edi,10010010010010010010010010010010y
	cmp edx,00100100100100100100100100100100y
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x CMP REG,IMMED:  %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	rol ecx,1
	ror esi,1
	rol edi,1
	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	cmp [max],ecx
	cmp [mdx],esi
	cmp [mcx],eax
	cmp [mdi],edx
	cmp [mcx],ecx
	cmp [mdi],edx
	cmp [mcx],eax
	cmp [msi],edi
	cmp [max],ecx
	cmp [msi],edx
	ENDM
PTIMER_END_LOOP_COUNT
	rol ecx,1
	ror esi,1
	rol edi,1
	invoke wsprintf,addr buffer,chr$("1000x CMP MEM,REG:    %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	cmp [max],10101010101010101010101010101010y
	cmp [mcx],01010101010101010101010101010101y
	cmp [max],10101010101010101010101010101010y
	cmp [mcx],01010101010101010101010101010101y
	cmp [mdx],00100100100100100100100100100100y
	cmp [msi],01001001001001001001001001001001y
	cmp [mdx],00100100100100100100100100100100y
	cmp [msi],01001001001001001001001001001001y
	cmp [mdi],10010010010010010010010010010010y
	cmp [mdx],00100100100100100100100100100100y
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x CMP MEM,IMMED:  %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer



; ----------------------------------------------------------------------------
	print chr$(13,10,"Failure-mode TEST tests:",13,10)
	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	test eax,ecx
	test edx,esi
	test ecx,eax
	test edi,edx
	test eax,ecx
	test esi,edi
	test ecx,eax
	test edx,edi
	test eax,ecx
	test edi,edx
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x TEST REG,REG:   %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	test eax,01010101010101010101010101010101y
	test edx,01001001001001001001001001001001y
	test ecx,10101010101010101010101010101010y
	test edi,01001001001001001001001001001001y
	test eax,01010101010101010101010101010101y
	test esi,00100100100100100100100100100100y
	test ecx,10101010101010101010101010101010y
	test edx,10010010010010010010010010010010y
	test eax,01010101010101010101010101010101y
	test edi,00100100100100100100100100100100y
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x TEST REG,IMMED: %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	test [max],ecx
	test [mdx],esi
	test [mcx],eax
	test [mdi],edx
	test [max],ecx
	test [msi],edi
	test [mcx],eax
	test [mdx],edi
	test [max],ecx
	test [mdi],edx
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x TEST MEM,REG:   %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	test [max],01010101010101010101010101010101y
	test [mdx],01001001001001001001001001001001y
	test [mcx],10101010101010101010101010101010y
	test [mdi],01001001001001001001001001001001y
	test [max],01010101010101010101010101010101y
	test [msi],00100100100100100100100100100100y
	test [mcx],10101010101010101010101010101010y
	test [mdx],10010010010010010010010010010010y
	test [max],01010101010101010101010101010101y
	test [mdi],00100100100100100100100100100100y
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x TEST MEM,IMMED: %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer



; ----------------------------------------------------------------------------
	print chr$(13,10,"Success-mode TEST tests:",13,10)
	rol ecx,1
	ror esi,1
	rol edi,1
	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	test eax,ecx
	test edx,esi
	test ecx,eax
	test edi,edx
	test eax,ecx
	test edi,edx
	test ecx,eax
	test esi,edi
	test eax,ecx
	test esi,edx
	ENDM
PTIMER_END_LOOP_COUNT
	rol ecx,1
	ror esi,1
	rol edi,1
	invoke wsprintf,addr buffer,chr$("1000x TEST REG,REG:   %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	test eax,10101010101010101010101010101010y
	test edx,01001001001001001001001001001001y
	test ecx,10101010101010101010101010101010y
	test edi,00100100100100100100100100100100y
	test eax,01010101010101010101010101010101y
	test edi,00100100100100100100100100100100y
	test ecx,10101010101010101010101010101010y
	test esi,10010010010010010010010010010010y
	test eax,01010101010101010101010101010101y
	test esi,00100100100100100100100100100100y
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x TEST REG,IMMED: %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	rol ecx,1
	ror esi,1
	rol edi,1
	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	test [max],ecx
	test [mdx],esi
	test [mcx],eax
	test [mdi],edx
	test [max],ecx
	test [mdi],edx
	test [mcx],eax
	test [msi],edi
	test [max],ecx
	test [msi],edx
	ENDM
PTIMER_END_LOOP_COUNT
	rol ecx,1
	ror esi,1
	rol edi,1
	invoke wsprintf,addr buffer,chr$("1000x TEST MEM,REG:   %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

	invoke Sleep,1000
PTIMER_START_LOOP_COUNT
	REPEAT 100
	test [max],10101010101010101010101010101010y
	test [mdx],01001001001001001001001001001001y
	test [mcx],10101010101010101010101010101010y
	test [mdi],00100100100100100100100100100100y
	test [max],01010101010101010101010101010101y
	test [mdi],00100100100100100100100100100100y
	test [mcx],10101010101010101010101010101010y
	test [msi],10010010010010010010010010010010y
	test [max],01010101010101010101010101010101y
	test [msi],00100100100100100100100100100100y
	ENDM
PTIMER_END_LOOP_COUNT
	invoke wsprintf,addr buffer,chr$("1000x TEST MEM,IMMED: %d clocks.",13,10),
			dword ptr [qwPTIMER_RESULT]
	print addr buffer

; ----------------------------------------------------------------------------
	inkey chr$(13,10,"Press any key to exit...")
	invoke ExitProcess,0

end start
OPT_Wait	0
OPT_Tmp2Asm	1
